const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inspection_results = sequelize.define(
    'inspection_results',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

result: {
        type: DataTypes.ENUM,
      
      

        values: [

"pass",


"fail",


"na"

        ],

      },

measured_value: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

measured_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inspection_results.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










































//end loop



    db.inspection_results.belongsTo(db.inspections, {
      as: 'inspection',
      foreignKey: {
        name: 'inspectionId',
      },
      constraints: false,
    });

    db.inspection_results.belongsTo(db.inspection_characteristics, {
      as: 'characteristic',
      foreignKey: {
        name: 'characteristicId',
      },
      constraints: false,
    });

    db.inspection_results.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inspection_results.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inspection_results.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inspection_results;
};


